<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlaceResultInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlaceResultInsert extends AbstractStructArrayBase
{
    /**
     * The PlaceResultInsert
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlaceResultInsert[]
     */
    public $PlaceResultInsert;
    /**
     * Constructor method for ArrayOfPlaceResultInsert
     * @uses ArrayOfPlaceResultInsert::setPlaceResultInsert()
     * @param \StructType\PlaceResultInsert[] $placeResultInsert
     */
    public function __construct(array $placeResultInsert = array())
    {
        $this
            ->setPlaceResultInsert($placeResultInsert);
    }
    /**
     * Get PlaceResultInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlaceResultInsert[]|null
     */
    public function getPlaceResultInsert()
    {
        return isset($this->PlaceResultInsert) ? $this->PlaceResultInsert : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlaceResultInsert method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlaceResultInsert method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlaceResultInsertForArrayConstraintsFromSetPlaceResultInsert(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlaceResultInsertPlaceResultInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfPlaceResultInsertPlaceResultInsertItem instanceof \StructType\PlaceResultInsert) {
                $invalidValues[] = is_object($arrayOfPlaceResultInsertPlaceResultInsertItem) ? get_class($arrayOfPlaceResultInsertPlaceResultInsertItem) : sprintf('%s(%s)', gettype($arrayOfPlaceResultInsertPlaceResultInsertItem), var_export($arrayOfPlaceResultInsertPlaceResultInsertItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlaceResultInsert property can only contain items of type \StructType\PlaceResultInsert, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlaceResultInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceResultInsert[] $placeResultInsert
     * @return \ArrayType\ArrayOfPlaceResultInsert
     */
    public function setPlaceResultInsert(array $placeResultInsert = array())
    {
        // validation for constraint: array
        if ('' !== ($placeResultInsertArrayErrorMessage = self::validatePlaceResultInsertForArrayConstraintsFromSetPlaceResultInsert($placeResultInsert))) {
            throw new \InvalidArgumentException($placeResultInsertArrayErrorMessage, __LINE__);
        }
        if (is_null($placeResultInsert) || (is_array($placeResultInsert) && empty($placeResultInsert))) {
            unset($this->PlaceResultInsert);
        } else {
            $this->PlaceResultInsert = $placeResultInsert;
        }
        return $this;
    }
    /**
     * Add item to PlaceResultInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceResultInsert $item
     * @return \ArrayType\ArrayOfPlaceResultInsert
     */
    public function addToPlaceResultInsert(\StructType\PlaceResultInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlaceResultInsert) {
            throw new \InvalidArgumentException(sprintf('The PlaceResultInsert property can only contain items of type \StructType\PlaceResultInsert, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlaceResultInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlaceResultInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlaceResultInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlaceResultInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlaceResultInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlaceResultInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlaceResultInsert
     */
    public function getAttributeName()
    {
        return 'PlaceResultInsert';
    }
}
